1 Star 0 Fork 2

k8s-devops/DevOps-Bash-tools

加入 Gitee
与超过 1200万 开发者一起发现、参与优秀开源项目,私有仓库也完全免费 :)
免费加入
文件
克隆/下载
check_yaml.sh 2.41 KB
一键复制 编辑 原始数据 按行查看 历史
Hari Sekhon 提交于 2020-02-13 11:20 . updated check_yaml.sh
#!/usr/bin/env bash
# vim:ts=4:sts=4:sw=4:et
#
# Author: Hari Sekhon
# Date: 2019-10-01 17:24:58 +0100 (Tue, 01 Oct 2019)
#
# https://github.com/harisekhon/bash-tools
#
# License: see accompanying Hari Sekhon LICENSE file
#
# If you're using my code you're welcome to connect with me on LinkedIn and optionally send me feedback to help improve or steer this or other code I publish
#
# http://www.linkedin.com/in/harisekhon
#
set -euo pipefail
[ -n "${DEBUG:-}" ] && set -x
srcdir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
# use .yamllint in $PWD or default to $srcdir/yamllint/config
export XDG_CONFIG_HOME="$srcdir"
# shellcheck source=lib/utils.sh
. "$srcdir/lib/utils.sh"
#if [ $# -gt 0 ]; then
# filelist="$*"
#else
# can point to test.json as an explicit argument
# could check *.json too but in DevOps Python Tools repo multirecord.json would break as this cannot handle multi-json record files
#filelist="$(find "${1:-.}" -type f -name '*.y*ml' -o -type f -name '*.json' | sort)"
filelist="$(find "${1:-.}" -type f -name '*.y*ml' | sort)"
#fi
if [ -z "$filelist" ]; then
return 0 &>/dev/null ||
exit 0
fi
section "YAML Syntax Checks"
start_time="$(start_timer)"
if [ -n "${NOSYNTAXCHECK:-}" ]; then
echo "\$NOSYNTAXCHECK environment variable set, skipping YAML syntax checks"
echo
elif [ -n "${QUICK:-}" ]; then
echo "\$QUICK environment variable set, skipping YAML syntax checks"
echo
else
if ! command -v yamllint &>/dev/null; then
echo "yamllint not found in \$PATH, not running YAML syntax checks"
return 0 &>/dev/null || exit 0
fi
max_len=0
for x in $filelist; do
if [ ${#x} -gt $max_len ]; then
max_len=${#x}
fi
done
# to account for the semi colon
((max_len + 1))
for x in $filelist; do
isExcluded "$x" && continue
printf "%-${max_len}s " "$x:"
set +eo pipefail
output="$(yamllint "$x")"
# shellcheck disable=SC2181
if [ $? -eq 0 ]; then
echo "OK"
else
echo "FAILED"
if [ -z "${QUIET:-}" ]; then
echo
echo "$output"
echo
fi
if [ -z "${NOEXIT:-}" ]; then
return 1 &>/dev/null || exit 1
fi
fi
set -eo pipefail
done
time_taken "$start_time"
section2 "All YAML files passed syntax check"
fi
echo
马建仓 AI 助手
尝试更多
代码解读
代码找茬
代码优化
1
https://gitee.com/k8s-devops/DevOps-Bash-tools.git
git@gitee.com:k8s-devops/DevOps-Bash-tools.git
k8s-devops
DevOps-Bash-tools
DevOps-Bash-tools
master

搜索帮助